wo.img = (function () {
	//获取照片的名称和类型
	function getname(path){
		if (path) {
		    var strs = path.split("/");
		    if (strs.length > 1) { var filename = strs.pop(); } else { return false; };
		    if (filename) { strs = filename.split("."); } else { return false; };
		    if (strs.length > 1) { var filetype = strs.pop(); var nickname = strs.pop(); } else { return false; };
		    if (filename && filetype && nickname) {
		    	var rtn = { filename: filename, filetype: filetype, simplename: nickname  };
		    	return rtn;
		    }else{
		    	return false;
		    }
		}else{
			return false;
		}
	}
	
	//显示相册相片
	function showImg(path, handler) {

	    if (0 != path.toString().indexOf("file://")) { path = "file://" + path; };
	    var file = getname(path);
	    if (!file) { handler && handler(null);  return false; }; 
	    var dst = plus.io.convertLocalFileSystemURL("_doc/"+file.filename);
	    if (0 != dst.toString().indexOf("file://")) { dst = "file://" + dst; };
	    //获取照片方向、尺寸、类型
	    var _img = new Image;
	    _img.src = path;
	    _img.onload = function(){
		    EXIF.getData(_img,function(){
		    	var iOt = EXIF.getTag(this,'Orientation');
		    	iOt = (typeof(iOt) == 'undefined') ? '1' : iOt;
		    	var comp_param = { src : path, dst : dst, type: file.filetype, Orientation:iOt, height:_img.height, width:_img.width };
		        _img.onload = null;
				_compressImg(comp_param,handler);
		    });
	    }; 
	};
	
	function _compressImg(opt, handler){
		var compressW = (opt.width > opt.height) ? ((opt.width > 800) ? 800 : opt.width ) : ((opt.height > 800) ? (800 * opt.width / opt.height) : opt.width);
		var compressH = (opt.width > opt.height) ? ((opt.width > 800) ? (800 * opt.height / opt.width) : opt.height ) : ((opt.height > 800) ? 800 : opt.height);
		var comprotate = (opt.Orientation == 6) ? 90 : ((opt.Orientation == 8) ? 270 : ((opt.Orientation == 3) ? 180 : 0));	
		
		comprotate = (plus.os.name == 'iOS') ? 0 : comprotate;
		var tempW = compressW, tempH = compressH;
		compressH = (plus.os.name == 'iOS') ? ((opt.Orientation == 6) ? tempW : tempH ) : compressH;
		compressW = (plus.os.name == 'iOS') ? ((opt.Orientation == 6) ? tempH : tempW ) : compressW;
		
		var param = { src: opt.src, dst: opt.dst, overwrite: true, format: opt.type, quality: 50, width: compressW+"px", height: compressH + "px", rotate: comprotate };
		plus.zip.compressImage(param, function(){
			handler && handler(opt.dst);
		}, function(e){
			handler && handler(null);
			console.log("compressed image error"+e.message);
		});
	};

	//裁剪头像
	function clipImg(clip, src, handler) {
		var file = getname(src);
	    var dst = plus.io.convertLocalFileSystemURL("_doc/clip" + file.filename);
		if (0 != dst.toString().indexOf("file://")) { dst = "file://" + dst; };
		var	clip_orig = { top: clip.y + "px", left: clip.x + "px", width: clip.width + "px", height: clip.height +"px" };
		var param = { src: src, dst: dst, overwrite: true, clip:clip_orig, quality: 100 };
		plus.zip.compressImage(param, function(){
			handler && handler(dst); 
		}, function(e){
			handler && handler(null);
			console.log("compressed thumb error"+e.message);
		});
	};
	
	//上传相片
	var rtnImgList = new Array;
	function uploadImgList(uid, imgUrlList, handler){
		var type = (imgUrlList.length > 1) ? 'multiple' : 'single';
		rtnImgList = [];
		_DoUploadImgList(uid, imgUrlList, type, handler);
	};
	
	function _DoUploadImgList(uid, imgUrlList, type, handler){
		
		if (imgUrlList.length > 0) {
			var imgUrl = imgUrlList.shift();
			uploadImg(uid, imgUrl, type, function(imgid, thumb_path, full_path){
				var rtnImg = { imgid : imgid, thumb_path : thumb_path, full_path : full_path };
				rtnImgList.push(rtnImg);
				_DoUploadImgList(uid, imgUrlList, type, handler);
			}, function(err){ handler && handler(null); });
		}else{
			var rtnData = rtnImgList;
			rtnImgList = [];
			handler && handler(rtnData);
		}; 
	};
	
	//上传单张图片
	function uploadImg(uid, path, type, handler) {
	    if (0 != path.toString().indexOf("file://")) { path = "file://" + path; };
	    var file = getname(path);
	    var rdm = Math.random();
	    rdm = String(Math.round(rdm*10000));
	    var dstname = file.simplename + rdm + 'thumb.' + file.filetype;
	    var tempdstname = file.simplename + rdm + 'clip.' + file.filetype;
	    
	    var dst = plus.io.convertLocalFileSystemURL("_doc"+dstname);
	    var temp_dst = plus.io.convertLocalFileSystemURL("_doc"+tempdstname);
	    if (0 != dst.toString().indexOf("file://")) { dst = "file://" + dst; }
	    if (0 != temp_dst.toString().indexOf("file://")) { temp_dst = "file://" + temp_dst; }
	    var _img = new Image;
	    _img.src = path; 
	    _img.onload = function(){
	    	var comp_param = { uid: uid, src : path, dst : dst, temp_dst : temp_dst, thumbtype:type, height:_img.height, width:_img.width };
	    	_img.onload = null; 
			_compressImgThumb(comp_param, handler);
	    };
	};
	
	function _compressImgThumb(opt, handler){
		var dst = opt.dst;
		var dst_t = opt.temp_dst;
		var src = opt.src;
		var uid = opt.uid;
		var size = (opt.thumbtype == 'single') ? 250 : 120; 
		var compressW = (opt.width > opt.height) ? ((opt.width > size) ? size : opt.width ) : ((opt.height > size) ? (size * opt.width / opt.height) : opt.width);
		var compressH = (opt.width > opt.height) ? ((opt.width > size) ? (size * opt.height / opt.width) : opt.height ) : ((opt.height > size) ? size : opt.height);
		
		if (opt.thumbtype == 'single') {  	
			var param = { src: src, dst: dst, overwrite: true, quality: 100, width: compressW+"px", height: compressH + "px"};				
		} else {
			var clip_orig = {};
			if (opt.width > opt.height) {
			    clip_orig = { top: 0 + "px", left: (opt.width - opt.height) / 2 + "px", width: opt.height + "px", height: opt.height + "px"	};
			} else {
			    clip_orig = { top: (opt.height - opt.width) / 2 + "px", left: 0 + "px", width: opt.width + "px", height: opt.width + "px" };			
			}; 
			var param = { src: src, dst: dst_t, overwrite: true, clip:clip_orig, quality:100 };
			var param_comp = { src: dst_t, dst: dst, overwrite: true, width:size + "px", quality: 100 };  
		};  
		plus.zip.compressImage(param, function(){
			if (opt.thumbtype != 'single') {
				plus.zip.compressImage(param_comp, function(){					
					upload(uid, src, dst, handler);
				}, function(e){
					handler && handler(null);
					console.log("compressed thumb error"+e.message);
				});
			}else{
				upload(uid, src, dst, handler);
			}
		}, function(e){
			handler && handler(null);
			console.log("compressed thumb error"+e.message);
		});
	};
	
	
	function upload(uid, src, dst, handler){  
		var url = 'http://api.wiqiapp.com/index.php/apiv2/image/upload';
		var task = plus.uploader.createUpload( url,	{ method:"POST",blocksize:102400,priority:100 },
				   function (t, status) {
						if (status == '200') {
							var data = JSON.parse(t.responseText);
							if (data.code == '1') {
								var imgid = data.info.imgid;
								if (0 != dst.toString().indexOf("file://")) { dst = "file://" + dst; };
								if (0 != src.toString().indexOf("file://")) { src = "file://" + src; };
								var arrSql = new Array;
								arrSql.push("INSERT INTO WQ_Img (imgid, thumb_path, full_path) SELECT " + imgid + ",'" + dst + "','" + src + "' WHERE NOT EXISTS (SELECT 1 FROM WQ_Img WHERE imgid = "+imgid+")");
								arrSql.push("UPDATE WQ_Img SET thumb_path = '"+dst+"', full_path = '"+src+"' WHERE imgid = "+imgid+" ");
								wo.excute(arrSql, function(){  
									handler && handler(imgid, dst, src);
								});
								
							}else{ handler && handler(null); };
						} else {
							handler && handler(null);;
							console.log( "Upload failed: " + status );
						};
					});
		var param = new Array;
		param[0]=['uid',uid];	
		var sign = wo._sign(param);
		//添加原图片
		task.addFile(src, {key:'full_path'});
		task.addFile(dst, {key:'thumb_path'});
		task.addData('uid', uid);
		task.addData('sign', sign);		
		task.start();
	};
	
	return {
		showImg: showImg, 
		clipImg:clipImg,
		uploadImg: uploadImg,
		uploadImgList: uploadImgList
	}
}());